diff --git a/test/unit/stages/review/fallback_coverage_test.rb b/test/unit/stages/review/fallback_coverage_test.rb
new file mode 100644
index 00000000..c5a02a64
--- /dev/null
+++ b/test/unit/stages/review/fallback_coverage_test.rb
@@ -0,0 +1,136 @@
+require "test_helper"
+require "hive/claude_completion_fallback"
+require "hive/stages/review"
+
+class HiveStagesReviewFallbackCoverageTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeTask = Struct.new(:folder, :slug, keyword_init: true)
+
+  def test_audits_an_accepted_fallback_with_required_context
+    with_tmp_dir do |dir|
+      task = FakeTask.new(folder: dir, slug: "demo-260720-aaaa")
+      evidence = Hive::ClaudeCompletionFallback::Evidence.new(
+        phase: "review_fix", sentinel_path: File.join(dir, ".done"),
+        missing_signal_reason: "stop_hook_sentinel_missing", session_name: "hive-fix",
+        pane_pid: 42, sentinel_missing: true, work_started: true,
+        returned_to_idle: true, stable_idle: true, session_readable: true,
+        no_failure_output: true, no_failure_result: true,
+        probe_accepted: true, exit_status: 0,
+        probe: {
+          artifacts_checked: [ "reviews/fix-result-01.json", "reviews/reviewer-01.md" ],
+          commit_range: "abc..def"
+        }
+      )
+      result = { status: :ok, completion: :fallback,
+                 fallback_decision: Hive::ClaudeCompletionFallback.evaluate(evidence) }
+
+      assert Hive::Stages::Review.fallback_completion?(result)
+      Hive::Stages::Review.emit_completion_fallback!(task, 1, result)
+
+      event = JSON.parse(File.readlines(File.join(dir, "events.jsonl")).last)
+      assert_equal "claude_completion_fallback", event.fetch("event_type")
+      assert_includes event.fetch("message"), "level=WARN"
+      assert_includes event.fetch("message"), "phase=review_fix"
+      assert_includes event.fetch("message"), "pass=01"
+      assert_includes event.fetch("message"), "task_slug=demo-260720-aaaa"
+      assert_includes event.fetch("message"), "missing_signal_reason=stop_hook_sentinel_missing"
+      assert_includes event.fetch("message"), "commit_range=abc..def"
+    end
+  end
+
+  def test_rejects_a_nonaccepted_or_nonfallback_result
+    refute Hive::Stages::Review.fallback_completion?(status: :ok)
+    refute Hive::Stages::Review.fallback_completion?(status: :timeout, completion: :fallback)
+  end
+
+  def test_long_audit_values_fit_event_limit_without_dropping_trailing_evidence
+    task = FakeTask.new(folder: "/tmp/task", slug: "s" * 300)
+    message = Hive::Stages::Review.completion_fallback_audit_message(
+      task,
+      1,
+      {
+        phase: "review_fix",
+        session_name: "session-#{'x' * 500}",
+        pane_pid: 42,
+        sentinel_path: "/tmp/#{'deep/' * 100}.done",
+        missing_signal_reason: "stop_hook_sentinel_missing",
+        artifacts_checked: Array.new(30) { |i| "/tmp/#{'artifact/' * 20}#{i}.md" },
+        commit_range: "#{'a' * 40}..#{'b' * 40}",
+        no_change_rationale: "reason-#{'z' * 600}"
+      }
+    )
+
+    assert_operator message.bytesize, :<=, Hive::Events::MAX_MESSAGE_BYTES
+    refute_includes message, Hive::Events::MESSAGE_TRUNCATION_SUFFIX
+    assert_includes message, "artifacts="
+    assert_includes message, "commit_range=#{'a' * 40}..#{'b' * 40}"
+    assert_includes message, "no_change_rationale=reason-"
+    assert_match(/no_change_rationale=.*~sha256=[0-9a-f]{12}/, message)
+  end
+
+  def test_fix_launcher_call_carries_the_semantic_completion_probe
+    with_tmp_dir do |dir|
+      task = Struct.new(:folder, :slug, :project_root, keyword_init: true).new(
+        folder: dir, slug: "demo-260720-aaaa", project_root: dir
+      )
+      ctx = Hive::Stages::Review::Context.new(
+        worktree_path: dir, task_folder: dir, default_branch: "main", pass: 1
+      )
+      captured = nil
+      scope = {
+        add_dirs: [ dir ], permission_mode: nil,
+        allowed_tools: Hive::ClaudeLauncher::IMPLEMENTER_ALLOWED_TOOLS, disallowed_tools: nil
+      }
+
+      with_replaced_singleton_method(Hive::Stages::Base, :stage_permission_scope, ->(*_) { scope }) do
+        with_replaced_singleton_method(Hive::Stages::Base, :spawn_claude!, lambda { |_task, _cfg, **kwargs|
+          captured = kwargs
+          { status: :ok }
+        }) do
+          Hive::Stages::Review.spawn_fix_agent(
+            task, { "claude" => { "mode" => "tmux" } }, ctx,
+            accepted: "[reviewer] - [x] fix", pass_start_head: "a" * 40
+          )
+        end
+      end
+
+      assert_equal :exit_code_only, captured.fetch(:status_mode)
+      assert_equal "review_fix", captured.fetch(:completion_phase)
+      assert_respond_to captured.fetch(:completion_probe), :call
+    end
+  end
+
+  def test_non_claude_fix_launchers_do_not_receive_claude_completion_keywords
+    %w[codex pi].each do |profile_name|
+      with_tmp_dir do |dir|
+        task = Struct.new(:folder, :slug, :project_root, keyword_init: true).new(
+          folder: dir, slug: "demo-260720-aaaa", project_root: dir
+        )
+        ctx = Hive::Stages::Review::Context.new(
+          worktree_path: dir, task_folder: dir, default_branch: "main", pass: 1
+        )
+        captured = nil
+        scope = { add_dirs: [ dir ], permission_mode: nil, allowed_tools: nil, disallowed_tools: nil }
+
+        with_replaced_singleton_method(Hive::Stages::Base, :stage_permission_scope, ->(*_) { scope }) do
+          with_replaced_singleton_method(Hive::Stages::Base, :spawn_agent, lambda { |_task, **kwargs|
+            captured = kwargs
+            { status: :ok }
+          }) do
+            Hive::Stages::Review.spawn_fix_agent(
+              task,
+              { "review" => { "fix" => { "agent" => profile_name } } },
+              ctx,
+              accepted: "[reviewer] - [x] fix",
+              pass_start_head: "a" * 40
+            )
+          end
+        end
+
+        refute captured.key?(:completion_phase), profile_name
+        refute captured.key?(:completion_probe), profile_name
+      end
+    end
+  end
+end
diff --git a/test/unit/stages/review/fix_completion_test.rb b/test/unit/stages/review/fix_completion_test.rb
new file mode 100644
index 00000000..8a08e098
--- /dev/null
+++ b/test/unit/stages/review/fix_completion_test.rb
@@ -0,0 +1,241 @@
+require "test_helper"
+require "json"
+require "hive/stages/review"
+require "hive/stages/review/fix_completion"
+
+class HiveStagesReviewFixCompletionTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup
+    @task_dir = Dir.mktmpdir("hive-fix-evidence-")
+    @worktree = Dir.mktmpdir("hive-fix-worktree-")
+    run!("git", "-C", @worktree, "init", "-b", "main", "--quiet")
+    run!("git", "-C", @worktree, "config", "user.email", "test@example.com")
+    run!("git", "-C", @worktree, "config", "user.name", "Test")
+    File.write(File.join(@worktree, "README.md"), "base\n")
+    run!("git", "-C", @worktree, "add", ".")
+    run!("git", "-C", @worktree, "commit", "-m", "base", "--quiet")
+    @start_head = `git -C #{@worktree} rev-parse HEAD`.strip
+    @ctx = Hive::Stages::Review::Context.new(
+      worktree_path: @worktree, task_folder: @task_dir, default_branch: "main", pass: 1
+    )
+    @slug = "demo-260720-aaaa"
+    FileUtils.mkdir_p(File.join(@task_dir, "reviews"))
+    File.write(File.join(@task_dir, "reviews", "reviewer-01.md"), "# Review\n\n- [x] fix this\n")
+    @expectation = Hive::Stages::Review::FixCompletion.expectation(@ctx)
+  end
+
+  def teardown
+    FileUtils.rm_rf(@task_dir)
+    FileUtils.rm_rf(@worktree)
+  end
+
+  def test_accepts_changed_evidence_for_descendant_commit_with_fix_trailers
+    File.write(File.join(@worktree, "README.md"), "fixed\n")
+    run!("git", "-C", @worktree, "add", ".")
+    run!("git", "-C", @worktree, "commit", "-m", <<~MSG, "--quiet")
+      fix: repair review finding
+
+      Hive-Task-Slug: #{@slug}
+      Hive-Fix-Pass: 01
+      Hive-Fix-Findings: 1
+      Hive-Triage-Bias: courageous
+      Hive-Reviewer-Sources: reviewer
+      Hive-Fix-Phase: fix
+    MSG
+    sha = `git -C #{@worktree} rev-parse HEAD`.strip
+    write_evidence(outcome: "changed", commits: [ sha ])
+
+    result = probe
+
+    assert result.fetch(:accepted), result.inspect
+    assert_equal "#{@start_head}..#{sha}", result.fetch(:commit_range)
+  end
+
+  def test_rejects_changed_evidence_without_commit_provenance
+    File.write(File.join(@worktree, "README.md"), "fixed\n")
+    run!("git", "-C", @worktree, "add", ".")
+    run!("git", "-C", @worktree, "commit", "-m", "fix: missing trailers", "--quiet")
+    write_evidence(outcome: "changed", commits: [ `git -C #{@worktree} rev-parse HEAD`.strip ])
+
+    result = probe
+
+    refute result.fetch(:accepted)
+    assert_match(/provenance/, result.fetch(:rejection_reason))
+  end
+
+  def test_rejects_empty_or_unclaimed_commits_in_pass_range
+    run!("git", "-C", @worktree, "commit", "--allow-empty", "-m", <<~MSG, "--quiet")
+      fix: claim work without a diff
+
+      Hive-Task-Slug: #{@slug}
+      Hive-Fix-Pass: 01
+      Hive-Fix-Findings: 1
+      Hive-Triage-Bias: courageous
+      Hive-Reviewer-Sources: reviewer
+      Hive-Fix-Phase: fix
+    MSG
+    empty_sha = `git -C #{@worktree} rev-parse HEAD`.strip
+    write_evidence(outcome: "changed", commits: [ empty_sha ])
+
+    empty_result = probe
+    refute empty_result.fetch(:accepted)
+    assert_match(/does not change any files/, empty_result.fetch(:rejection_reason))
+
+    run!("git", "-C", @worktree, "reset", "--hard", @start_head, "--quiet")
+    File.write(File.join(@worktree, "README.md"), "fixed\n")
+    run!("git", "-C", @worktree, "add", ".")
+    run!("git", "-C", @worktree, "commit", "-m", <<~MSG, "--quiet")
+      fix: claimed review fix
+
+      Hive-Task-Slug: #{@slug}
+      Hive-Fix-Pass: 01
+      Hive-Fix-Findings: 1
+      Hive-Triage-Bias: courageous
+      Hive-Reviewer-Sources: reviewer
+      Hive-Fix-Phase: fix
+    MSG
+    claimed = `git -C #{@worktree} rev-parse HEAD`.strip
+    File.write(File.join(@worktree, "unrelated.txt"), "extra\n")
+    run!("git", "-C", @worktree, "add", ".")
+    run!("git", "-C", @worktree, "commit", "-m", "chore: unrelated", "--quiet")
+    write_evidence(outcome: "changed", commits: [ claimed ])
+
+    unclaimed_result = probe
+    refute unclaimed_result.fetch(:accepted)
+    assert_match(/claim every commit in the pass range/, unclaimed_result.fetch(:rejection_reason))
+  end
+
+  def test_accepts_explicit_no_change_evidence_without_a_new_commit
+    write_evidence(outcome: "no_changes_needed", commits: [], rationale: "Finding already covered by current code.")
+
+    result = probe
+
+    assert result.fetch(:accepted), result.inspect
+    assert_equal "Finding already covered by current code.", result.fetch(:no_change_rationale)
+  end
+
+  def test_rejects_no_change_evidence_when_head_advanced_even_without_a_diff
+    run!("git", "-C", @worktree, "commit", "--allow-empty", "-m", "chore: empty", "--quiet")
+    write_evidence(outcome: "no_changes_needed", commits: [])
+
+    result = probe
+
+    refute result.fetch(:accepted)
+    assert_match(/must not advance HEAD/, result.fetch(:rejection_reason))
+  end
+
+  def test_rejects_malformed_or_stale_evidence
+    File.write(Hive::Stages::Review::FixCompletion.evidence_path(@ctx), "{")
+    malformed = probe
+    refute malformed.fetch(:accepted)
+    assert_match(/invalid JSON/, malformed.fetch(:rejection_reason))
+
+    write_evidence(outcome: "no_changes_needed", commits: [], pass: 2)
+    stale = probe
+    refute stale.fetch(:accepted)
+    assert_match(/pass/, stale.fetch(:rejection_reason))
+  end
+
+  def test_rejects_dirty_worktree_even_when_no_change_evidence_is_well_formed
+    write_evidence(outcome: "no_changes_needed", commits: [])
+    File.write(File.join(@worktree, "uncommitted.rb"), "puts :not_evidence\n")
+
+    result = probe
+
+    refute result.fetch(:accepted)
+    assert_match(/uncommitted changes/, result.fetch(:rejection_reason))
+  end
+
+  def test_rejects_incomplete_or_arbitrary_finding_dispositions
+    write_evidence(outcome: "no_changes_needed", commits: [], findings: [])
+    incomplete = probe
+    refute incomplete.fetch(:accepted)
+    assert_match(/exactly match accepted findings/, incomplete.fetch(:rejection_reason))
+
+    write_evidence(
+      outcome: "no_changes_needed",
+      commits: [],
+      findings: [ { "id" => expected_finding_id, "disposition" => "whatever" } ]
+    )
+    arbitrary = probe
+    refute arbitrary.fetch(:accepted)
+    assert_match(/disposition is invalid/, arbitrary.fetch(:rejection_reason))
+  end
+
+  def test_rejects_finding_dispositions_that_contradict_the_outcome
+    write_evidence(
+      outcome: "no_changes_needed",
+      commits: [],
+      findings: [ { "id" => expected_finding_id, "disposition" => "addressed" } ]
+    )
+    no_change = probe
+    refute no_change.fetch(:accepted)
+    assert_match(/no-change completion.*no change needed/, no_change.fetch(:rejection_reason))
+
+    write_evidence(
+      outcome: "changed",
+      commits: [ "a" * 40 ],
+      findings: [ { "id" => expected_finding_id, "disposition" => "no change needed" } ]
+    )
+    changed = probe
+    refute changed.fetch(:accepted)
+    assert_match(/changed completion.*addressed/, changed.fetch(:rejection_reason))
+  end
+
+  def test_git_probe_timeout_fails_closed
+    write_evidence(outcome: "no_changes_needed", commits: [])
+
+    with_replaced_singleton_method(Timeout, :timeout, ->(*) { raise Timeout::Error }) do
+      result = probe
+
+      refute result.fetch(:accepted)
+      assert_match(/git status timed out/, result.fetch(:rejection_reason))
+    end
+  end
+
+  def test_rejects_reviewer_file_rewrite_after_expectation_snapshot
+    write_evidence(outcome: "no_changes_needed", commits: [])
+    File.write(File.join(@task_dir, "reviews", "reviewer-01.md"), "# forged\n\n- [x] different finding\n")
+
+    result = probe
+
+    refute result.fetch(:accepted)
+    assert_match(/changed after fix dispatch/, result.fetch(:rejection_reason))
+  end
+
+  private
+
+  def probe
+    Hive::Stages::Review::FixCompletion.probe(
+      ctx: @ctx,
+      task_slug: @slug,
+      pass_start_head: @start_head,
+      expectation: @expectation
+    )
+  end
+
+  def write_evidence(outcome:, commits:, rationale: "Applied the accepted finding.", pass: 1,
+                     findings: nil)
+    disposition = outcome == "changed" ? "addressed" : "no change needed"
+    findings ||= [ { "id" => expected_finding_id, "disposition" => disposition } ]
+    File.write(
+      Hive::Stages::Review::FixCompletion.evidence_path(@ctx),
+      JSON.pretty_generate(
+        "version" => 1,
+        "pass" => pass,
+        "task_slug" => @slug,
+        "outcome" => outcome,
+        "rationale" => rationale,
+        "findings" => findings,
+        "commits" => commits,
+        "unresolved_escalation" => false,
+        "missing_output" => false
+      )
+    )
+  end
+
+  def expected_finding_id
+    @expectation.finding_ids.fetch(0)
+  end
+end
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57a..16722b73 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -27,6 +27,27 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_install_uses_the_explicit_resolved_completion_paths_in_every_settings_scope
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir do |cwd|
+        done_path, result_path = Hive::StopHookInstaller.completion_paths(stage_dir)
+        paths = Hive::StopHookInstaller.install(
+          stage_dir: stage_dir,
+          extra_dirs: [ cwd ],
+          done_path: done_path,
+          result_path: result_path
+        )
+
+        paths.each do |path|
+          command = JSON.parse(File.read(path)).dig("hooks", "Stop", 0, "hooks", 0, "command")
+          assert_includes command, "HIVE_STOP_HOOK_DONE_PATH=#{Shellwords.escape(done_path)}"
+          assert_includes command, "HIVE_STOP_HOOK_RESULT_PATH=#{Shellwords.escape(result_path)}"
+          assert_includes command, "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(stage_dir)}"
+        end
+      end
+    end
+  end
+
   def test_install_is_idempotent
     with_tmp_dir do |dir|
       first = Hive::StopHookInstaller.install(stage_dir: dir)
@@ -70,6 +91,64 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_install_rolls_back_completed_scopes_when_a_later_scope_fails
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir do |extra_dir|
+        settings = File.join(stage_dir, ".claude", "settings.json")
+        FileUtils.mkdir_p(File.dirname(settings))
+        original = %({"project":true})
+        File.write(settings, original)
+        calls = 0
+        real_install_at = Hive::StopHookInstaller.method(:install_at)
+
+        with_replaced_singleton_method(Hive::StopHookInstaller, :install_at, lambda { |*args, **kwargs|
+          calls += 1
+          raise Errno::EACCES, "extra cwd is read-only" if calls == 2
+
+          real_install_at.call(*args, **kwargs)
+        }) do
+          assert_raises(Errno::EACCES) do
+            Hive::StopHookInstaller.install(stage_dir: stage_dir, extra_dirs: [ extra_dir ])
+          end
+        end
+
+        assert_equal original, File.read(settings),
+                     "a later-scope install failure must restore the earlier project settings"
+        refute File.exist?("#{settings}#{Hive::StopHookInstaller::BACKUP_SUFFIX}")
+      end
+    end
+  end
+
+  def test_install_rolls_back_a_duplicate_completed_scope_only_once
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir do |extra_dir|
+        settings = File.join(extra_dir, ".claude", "settings.json")
+        FileUtils.mkdir_p(File.dirname(settings))
+        original = %({"project":true})
+        File.write(settings, original)
+        calls = 0
+        real_install_at = Hive::StopHookInstaller.method(:install_at)
+
+        with_replaced_singleton_method(Hive::StopHookInstaller, :install_at, lambda { |*args, **kwargs|
+          calls += 1
+          raise Errno::EACCES, "later cwd is read-only" if calls == 4
+
+          real_install_at.call(*args, **kwargs)
+        }) do
+          assert_raises(Errno::EACCES) do
+            Hive::StopHookInstaller.install(
+              stage_dir: stage_dir,
+              extra_dirs: [ extra_dir, extra_dir, File.join(stage_dir, "unwritable") ]
+            )
+          end
+        end
+
+        assert_equal original, File.read(settings),
+                     "a duplicated settings path must not be deleted by a second rollback"
+      end
+    end
+  end
+
   def test_install_skips_extra_dir_equal_to_stage_dir
     with_tmp_dir do |dir|
       paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ dir ])
@@ -132,11 +211,61 @@ class StopHookInstallerTest < Minitest::Test
       out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: payload)
 
       assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
-      assert_equal payload, File.read(File.join(dir, "result.json"))
+      result = JSON.parse(File.read(File.join(dir, "result.json")))
+      assert_equal "abc", result.fetch("session_id")
+      assert_equal "success", result.fetch("status"),
+                   "a normal Claude Stop payload without status must be explicit success evidence"
+      assert result.fetch("hive_stop_hook_invoked_at")
+      assert_kind_of Integer, result.fetch("hive_stop_hook_pid")
       assert File.exist?(File.join(dir, ".done"))
     end
   end
 
+  def test_stop_hook_marks_empty_stdin_as_non_success
+    with_tmp_dir do |dir|
+      _out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "")
+
+      assert status.success?, err
+      result = JSON.parse(File.read(File.join(dir, "result.json")))
+      assert_equal "empty_stdin", result.fetch("status")
+      assert_equal "empty_stdin", result.fetch("hive_stop_hook")
+      assert File.exist?(File.join(dir, ".done")),
+             "the sentinel wakes the launcher, which rejects the non-success result"
+    end
+  end
+
+  def test_stop_hook_does_not_publish_done_when_input_is_not_json
+    with_tmp_dir do |dir|
+      _out, _err, status = Open3.capture3(
+        { "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "not json"
+      )
+
+      refute status.success?
+      refute File.exist?(File.join(dir, ".done")), "a failed result publication must not signal completion"
+    end
+  end
+
+  def test_stop_hook_honors_paths_with_spaces_and_shell_characters
+    Dir.mktmpdir("hive stop hook ; ") do |dir|
+      done_path = File.join(dir, "done ; $d")
+      result_path = File.join(dir, "result ; $r.json")
+      payload = %({"status":"success"})
+      _out, err, status = Open3.capture3(
+        {
+          "HIVE_TASK_STAGE_DIR" => dir,
+          "HIVE_STOP_HOOK_DONE_PATH" => done_path,
+          "HIVE_STOP_HOOK_RESULT_PATH" => result_path
+        },
+        HOOK,
+        stdin_data: payload
+      )
+
+      assert status.success?, err
+      assert_equal "success", JSON.parse(File.read(result_path)).fetch("status")
+      assert File.exist?(done_path)
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
diff --git a/test/unit/tmux_runner_test.rb b/test/unit/tmux_runner_test.rb
index 005bccda..498347b7 100644
--- a/test/unit/tmux_runner_test.rb
+++ b/test/unit/tmux_runner_test.rb
@@ -282,6 +282,29 @@ class TmuxRunnerTest < Minitest::Test
     end
   end
 
+  def test_remain_on_exit_and_dead_status_use_tmux_pane_metadata
+    with_tmp_dir do |dir|
+      log_path = File.join(dir, "tmux.log")
+      fake = write_fake_tmux(dir, <<~RUBY)
+        #!/usr/bin/env ruby
+        args = ARGV.dup
+        args.shift(2) if args.first == "-L"
+        File.open(#{log_path.dump}, "a") { |log| log.puts(args.join(" ")) }
+        if args.first == "display-message"
+          puts(args.last == '\#{pane_dead}' ? "1" : "0")
+        end
+      RUBY
+      runner = Hive::TmuxRunner.new(
+        name: unique_name("dead-status"), cwd: dir, tmux_bin: fake, socket_name: @socket_name
+      )
+
+      assert runner.enable_remain_on_exit
+      assert runner.pane_dead?
+      assert_equal 0, runner.pane_dead_status
+      assert_includes File.read(log_path), "set-option"
+    end
+  end
+
   def test_session_exists_returns_false_when_tmux_missing
     with_tmp_dir do |dir|
       runner = Hive::TmuxRunner.new(name: unique_name("missing-exists"), cwd: dir, tmux_bin: "missing-tmux-for-hive")
